commit b9bbaa400d6a758e9dd6896035f971fc41dacf7b
Author: freddy77 <freddy77>
Date:   Thu Jan 10 08:47:37 2008 +0000

    fix SQLNumResultCols() is wrong (+1) problem

diff --git a/ChangeLog b/ChangeLog
index 1bfbe78..d1d80dd 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,10 @@
+Thu Jan 10 09:46:41 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* TODO src/odbc/odbc.c src/odbc/unittests/.cvsignore:
+	* src/odbc/unittests/Makefile.am:
+	- small fix for hidden fields (ignore them entirely)
+
 Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2456 2008/01/10 01:02:20 jklowden Exp $
+$Id: ChangeLog,v 1.2457 2008/01/10 08:47:37 freddy77 Exp $
diff --git a/TODO b/TODO
index 6b770b4..49074e8 100644
--- a/TODO
+++ b/TODO
@@ -8,7 +8,7 @@ anyone else can post a patch to Source Forge.
 In this way we can communicate with each
 other about the project's priorities and needs.  
 
-To Do List	$Id: TODO,v 1.165 2007/12/26 20:56:00 freddy77 Exp $
+To Do List	$Id: TODO,v 1.166 2008/01/10 08:47:37 freddy77 Exp $
 ------------
 
 Bug? ML 2007-05-30 "dbsqlexec() never returns" 
@@ -131,6 +131,14 @@ For future versions (in priority order within library):
 . report error just before returning SQL_ERROR from inner function?
 
 . test and fix: hidden fields (FOR BROWSE select, see flag test on tds)
+ - what happen if we bind to an hidden field??
+ - if we use SQLGetData??
+ - if we request informations with SQLDescribeCol/SQLColAttribute(s)/
+   SQLGetDescField??
+ - as you noted returning # columns hidden fields are not counted (there
+   is however a setting which is a mssql extension which threat hidden
+   columns as normal)
+ (cfr "SQLNumResultCols() is wrong (+1)" Jan 8 2008)
 . test: all binding types (input and output)
 . test: descriptors work
   - ODBC 2 type returned (datetime)
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 7180d23..a19f734 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.464 2008/01/06 10:48:43 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.465 2008/01/10 08:47:37 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -2652,7 +2652,7 @@ odbc_ird_check(TDS_STMT * stmt)
 		return;
 
 	/* check columns number */
-	assert(ird->header.sql_desc_count == cols || ird->header.sql_desc_count == 0);
+	assert(ird->header.sql_desc_count <= cols || ird->header.sql_desc_count == 0);
 
 
 	/* check all columns */
@@ -2717,6 +2717,10 @@ odbc_populate_ird(TDS_STMT * stmt)
 		return SQL_SUCCESS;
 	num_cols = res_info->num_cols;
 
+	/* ignore hidden columns... TODO correct? */
+	while (num_cols > 0 && res_info->columns[num_cols - 1]->column_hidden == 1)
+		--num_cols;
+
 	if (desc_alloc_records(ird, num_cols) != SQL_SUCCESS) {
 		odbc_errs_add(&stmt->errs, "HY001", NULL);
 		return SQL_ERROR;
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index d6eea5a..1316adb 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -62,3 +62,4 @@ cursor3
 cursor4
 cursor5
 attributes
+hidden
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index e68b0a4..14726b2 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.68 2007/12/19 14:36:05 freddy77 Exp $
+# $Id: Makefile.am,v 1.69 2008/01/10 08:47:38 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -20,7 +20,7 @@ TESTS		=	\
 			paramcore$(EXEEXT) timeout2$(EXEEXT) timeout3$(EXEEXT) \
 			connect2$(EXEEXT) timeout4$(EXEEXT) freeclose$(EXEEXT) \
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
-			attributes$(EXEEXT)
+			attributes$(EXEEXT) hidden$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -77,6 +77,7 @@ cursor3_SOURCES	= cursor3.c common.c common.h
 cursor4_SOURCES	= cursor4.c common.c common.h
 cursor5_SOURCES	= cursor5.c common.c common.h
 attributes_SOURCES	= attributes.c common.c common.h
+hidden_SOURCES	= hidden.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32

